package edu.mtech.esof427.keyboard;

public class Circle extends Shape
{
    private double radius = 0.0;

    public Circle(Point center, double radius)
    {
        super(center);
        this.radius = radius;
    }

    public double getRadius()
    {
        return radius;
    }

    @Override
    public boolean isInside(Point point)
    {
        double distance = point.getDistance(getCenter());
        return (distance <= radius);
    }
    
    // Bounding box of a circle is a square center at the same location
    public Rectangle getBoundingBox()
    {
        return new Rectangle(getCenter(), radius * 2.0, radius * 2.0);
    }
    
    public String toString()
    {
        return String.format("[CIRCLE %s r=%.2f]", getCenter().toString(), radius);
    }
    
}
