package edu.mtech.esof427.keyboard;

public class ComputeTraceLast implements ComputeTrace
{
    @Override
    public Point getFocalPoint(Trace trace)
    {
        Touch touch = trace.get(0);
        
        if (touch instanceof TouchTime)
        {
            long maxTime = Long.MIN_VALUE;
            Point maxPoint = null;
            
            for (int i = 0; i < trace.size(); i++)
            {
                touch = trace.get(i);
                
                // If we have multitouch information, then we only count the 0-index finger
                if ((!(touch instanceof TouchFinger) ||
                    ((TouchFinger) touch).getFingerId() == 0))
                {
                    long time = ((TouchTime) touch).getTimeStampInMs();
                    if (time > maxTime)
                    {
                        maxTime = time;
                        maxPoint = touch.getLocation();
                    }
                }                    
            }
            return maxPoint;
        }
        else
        {
            // Without any timing information, we just use the last one
            return trace.get(trace.size() - 1).getLocation();
        }
    }
}
