package edu.mtech.esof427.keyboard;

public abstract class Shape
{
    private Point center;

    public Shape(Point center)
    {
        this.center = new Point(center);
    }
    
    public Point getCenter()
    {
        return center;
    }

    // Determine the distance from the center of this shape to some other point
    public double getDistanceToCenter(Point point)
    {
        return point.getDistance(center);
    }
    
    // Return a bounding rectangle containing this shape
    public abstract Rectangle getBoundingBox();
    
    // Determine if the given point is inside or on the boundary of this shape
    public abstract boolean isInside(Point point);
    
    // See if the bounding boxes of two shapes intersect
    public boolean doBoundingBoxesIntersect(Shape other)
    {
        Rectangle myBox    = getBoundingBox();
        Rectangle otherBox = other.getBoundingBox();
        
        return myBox.intersects(otherBox);
    }
    
}
