package edu.mtech.esof427.keyboard;

public class TouchFinger extends TouchTime
{
    private int fingerId = 0;
    
    public TouchFinger(Point location, long timeStampInMs, int fingerId)
    {
        super(location, timeStampInMs);
        this.fingerId = fingerId;
    }    
 
    public TouchFinger(String data)
    {
        String [] cols = data.split(",");
        if (cols.length != 4)
            throw new RuntimeException("TouchFinger constructor expects 4 pieces of data!");

        double x = Double.parseDouble(cols[0]);
        double y = Double.parseDouble(cols[1]);
        setLocation(new Point(x, y));
        
        long t = Long.parseLong(cols[2]);
        setTimeStampInMs(t);

        this.fingerId = Integer.parseInt(cols[3]);
    }
    
    public int getFingerId()
    {
        return fingerId;
    }
    
    public String toString()
    {
        return String.format("[TOUCH %s t=%d f=%d]", getLocation().toString(), getTimeStampInMs(), fingerId);
    }

}
