package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;

import org.junit.Test;
import edu.mtech.esof427.keyboard.*;
import java.io.*;

public class CircleKeyboardTest
{
    private static final String KEYBOARD = "keyboard_circle.txt";
    private static final String TRACE = "mobile643.txt";
   
    @Test
    public void testGetTextAvg() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 0, false);
        assertTrue(result.equals("olay_eiyj_me"));
    }

    @Test
    public void testGetTextAvgInside() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 0, true);
        assertTrue(result.equals("ayijm"));
    }
    
    @Test
    public void testGetTextFirst() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 1, false);
        assertTrue(result.equals("olay_witj_me"));
    }

    @Test
    public void testGetTextFirstInside() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 1, true);
        assertTrue(result.equals("layijm"));
    }
    
    @Test
    public void testGetTextLast() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 2, false);
        assertTrue(result.equals("okay_eiyj_me"));
    }

    @Test
    public void testGetTextLastInside() throws IOException
    {
        CircleKeyboard keyboard = new CircleKeyboard(KEYBOARD);
        
        TraceSequence sequence = new TraceSequence(TRACE, 0);
        String result = keyboard.getText(sequence, 2, true);
        assertTrue(result.equals("oayiyjm"));
    }
    
}
