package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;

import org.junit.Test;
import edu.mtech.esof427.keyboard.*;

public class PointTest 
{
    private final static double EPSILON = 1e-10;

    @Test
    public void testGet() 
    {
        Point p = new Point(5.0, 6.0);
        assertEquals(5.0, p.getX(), EPSILON);
        assertEquals(6.0, p.getY(), EPSILON);
    }

    @Test
    public void testToString() 
    {
        Point p = new Point(5.0, 6.0);
        String str = p.toString();
        assertTrue(str.length() > 0);
    }

    @Test
    public void testDistanceVertical() 
    {
        Point p1 = new Point(0.0, 10.0);
        Point p2 = new Point(0.0, -10.0);        
        assertEquals(20.0, p1.getDistance(p2), EPSILON);
    }

    @Test
    public void testDistanceHorizontal() 
    {
        Point p1 = new Point(5.0, 0.0);
        Point p2 = new Point(-5.0, 0.0);        
        assertEquals(10.0, p1.getDistance(p2), EPSILON);
    }

    @Test
    public void testDistanceRandom() 
    {
        for (int i = 0; i < 10000; i++)
        {
            Point p1 = new Point(Math.random(), Math.random());
            Point p2 = new Point(Math.random(), Math.random());

            double deltaX = p1.getX() - p2.getX();
            double deltaY = p1.getY() - p2.getY();
            double dist   = Math.sqrt(deltaX * deltaX + deltaY * deltaY);
            
            assertEquals(dist, p1.getDistance(p2), EPSILON);
        }
    }

}
