package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;

import org.junit.Test;
import edu.mtech.esof427.keyboard.*;

public class TouchTimeTest
{
    private final static double EPSILON = 1e-8;
    
    @Test
    public void testToString()
    {
        TouchTime time = new TouchTime(new Point(1.0, 2.0), 12345);
        
        String str = time.toString();
        assertTrue(str.length() > 0);
    }

    @Test
    public void testGetTime()
    {
        TouchTime time = new TouchTime(new Point(1.0, 2.0), 12345);        
        assertEquals(12345, time.getTimeStampInMs());
    }
    
    @Test
    public void testGetLocation()
    {
        TouchTime time = new TouchTime(new Point(1.0, 2.0), 12345);        
        Point location = time.getLocation();
        
        assertEquals(1.0, location.getX(), EPSILON);
        assertEquals(2.0, location.getY(), EPSILON);
        
    }
}
